using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using UniDAQ_Ns;


namespace Memory_RW
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        const uint dwDataNum = 100;
        ushort wTotalBoard, wRtn, wBoardNo;
        float[] fBuf = new float[dwDataNum];

        UniDAQ.IXUD_CARD_INFO[] sCardInfo = new UniDAQ.IXUD_CARD_INFO[32];
        UniDAQ.IXUD_DEVICE_INFO[] sDeviceInfo = new UniDAQ.IXUD_DEVICE_INFO[32];

        private void Form1_Load(object sender, System.EventArgs e)
        {
            byte[] szModeName = new byte[20];
            //Driver Initial
            wRtn = UniDAQ.Ixud_DriverInit(ref wTotalBoard);
            if (wRtn != UniDAQ.Ixud_NoErr)
            {
                MessageBox.Show("Driver Initial Error!!Error Code:" + wRtn.ToString());
                Close();
                return;
            }

            for (ushort wBoardIndex = 0; wBoardIndex < wTotalBoard; wBoardIndex++)
            {
                //Get Card Information
                wRtn = UniDAQ.Ixud_GetCardInfo(wBoardIndex, ref sDeviceInfo[wBoardIndex], ref sCardInfo[wBoardIndex], szModeName);
                this.cbxSelectBoard.Items.Add(Encoding.ASCII.GetString(szModeName));
            }
        }

        private void cbxSelectBoard_SelectedIndexChanged(object sender, EventArgs e)
        {
            wBoardNo = (ushort)cbxSelectBoard.SelectedIndex;
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            //Release the UniDAQ Driver resource
            wRtn = UniDAQ.Ixud_DriverClose();
            Application.Exit();
            this.Close();
        }


        private void btnWrite_Click(object sender, System.EventArgs e)
        {
            if ((cbxSelectBoard.SelectedIndex == -1))
            {
                MessageBox.Show("Please Selected a Board!!!");
                return;
            }

            wRtn = UniDAQ.Ixud_WriteMemory(wBoardNo, UInt32.Parse(tbxOffset.Text), UInt16.Parse(cbxSize.Text), UInt32.Parse(tbxWrite.Text, System.Globalization.NumberStyles.AllowHexSpecifier));
            if (wRtn > 0)
            {
                MessageBox.Show("Error " + wRtn.ToString());
            }

        }

        private void btnRead_Click(object sender, System.EventArgs e)
        {
            UInt32 dwValue = 0x0;
            if ((cbxSelectBoard.SelectedIndex == -1))
            {
                MessageBox.Show("Please Selected a Board!!!");
                return;
            }

            wRtn = UniDAQ.Ixud_ReadMemory(wBoardNo, UInt32.Parse(tbxOffset.Text), UInt16.Parse(cbxSize.Text), ref dwValue);
            if (wRtn > 0)
            {
                MessageBox.Show("Error " + wRtn.ToString());
            }

            tbxRead.Text = ("0x" + Convert.ToString(dwValue, 16));
        }
    }
}
